﻿local addon = CreateFrame("Frame")
local _G = _G

addon:SetScript("OnEvent", function(self, event, ...)
	if self[event] then self[event](self, event, ...) end
end)
addon:RegisterEvent("PLAYER_LOGIN")
addon:RegisterEvent("ADDON_LOADED")

function addon:DoSetup(event, addon_name)
	if event == "ADDON_LOADED" then
		if addon_name ~= "AltoComplete" then return end
	end
	if not IsLoggedIn() then return end
	self.db_object = LibStub("AceDB-3.0"):New("AltoCompleteDB", {
		profile = {
			cutoff = 30, -- number of days before an alt is removed from consideration
		},
		factionrealm = {
			chars = {},
		},
	})
	self.chars = self.db_object.factionrealm.chars
	
	self.current = UnitName("player")
	self.chars[self.current] = time()
end
addon.PLAYER_LOGIN = addon.DoSetup
addon.ADDON_LOADED = addon.DoSetup

local old_PlayerNameAutocomplete = PlayerNameAutocomplete
PlayerNameAutocomplete = function(...)
	if not addon:Autocomplete(...) then
		old_PlayerNameAutocomplete(...)
	end
end
function addon:Autocomplete(box)
	local base_text = SendMailNameEditBox:GetText()
	local find_string = "^"..string.upper(base_text)
	for name, lastseen in pairs(self.chars) do
		if name ~= self.current and string.upper(name):find(find_string) then
			SendMailNameEditBox:SetText(name)
			SendMailNameEditBox:HighlightText(#base_text, -1)
			return true
		end
	end
end

